$ZAPT_Temp::Mutation::Name = "Tank";
$ZAPT_Temp::Mutation::uiName = "Man vs Tank";
$ZAPT_Temp::Mutation::Bots = false;
$ZAPT_Temp::Mutation::HumanRespawn = false;
$ZAPT_Temp::Mutation::Saferooms = false;

function Mutation_Tank_Assemble(%mini)
{
	if(%mini.numMembers < 2)
	{
		%mini.messageAll('', "<color:ffaaaa>You cannot play Man vs Tank without at least 2 players.");
		%mini.ZAPT_GameMode = 0;
		return false;
	}
	else if(!%mini.zombieAssembledOnce)
	{
		for(%a = 0; %a < %mini.numMembers; %a++)
		{
			%infClient = %mini.member[%a];
			
			if(!%infClient.isAFK)
			{
				%odds = %mini.numMembers + %infClient.zombieVersusInRow - 1;
				
				if(%odds <= 0 || !getRandom(0, %odds))
				{
					if(isObject(%infClient.player))
					{
						%infClient.player.getDatablock().zombieCameraSpectate(%infClient.player);
						%infClient.player.delete();
					}
					
					%infClient.isZombie = true;
					%infClient.zombieVersusInRow += (%mini.numMembers - 1);
					%infClient.zombieSpawnAsTankSched = %infClient.schedule(10000, "spawnAsTank");
					messageClient(%infClient, '', "<color:ffffaa>You were picked to play Tank.");
					
					%mini.zombieTank = %infClient;
					%mini.zombieTankSpawnOn = $sim::time + 10;
					
					break;
				}
			}
		}
		
		if(!isObject(%mini.zombieTank))
		{
			for(%a = 0; %a < %mini.numMembers; %a++)
			{
				%infClient = %mini.member[%a];
				
				if(!%infClient.isAFK)
				{
					if(%list $= "")
					{
						%list = %infClient;
					}
					else
					{
						%list = %list SPC %infClient;
					}
				}
			}
			
			%tank = getWord(%list, getRandom(0, getWordCount(%list)));
			
			if(isObject(%tank))
			{
				if(isObject(%tank.player))
				{
					%tank.player.getDatablock().zombieCameraSpectate(%tank.player);
					%tank.player.delete();
				}
				
				%tank.isZombie = true;
				%tank.zombieVersusInRow += (%mini.numMembers - 1);
				%tank.zombieSpawnAsTankSched = %tank.schedule(10000, "spawnAsTank");
				messageClient(%tank, '', "<color:ffffaa>You were picked to play Tank.");
				
				%mini.zombieTank = %tank;
				%mini.zombieTankSpawnOn = $sim::time + 10;
			}
			else
			{
				%mini.messageAll('', "<color:ffaaaa>Could not pick tank!");
				%mini.ZAPT_GameMode = 0;
				return false;
			}
		}
		
		for(%a = 0; %a < %mini.numMembers; %a++)
		{
			%infClient = %mini.member[%a];
			
			if(!%infClient.isZombie)
			{
				%infClient.zombieVersusInRow--;
			}
		}
	}
	
	%mini.ZAPT_Tank = false;
	%mini.ZAPT_Mobs = false;
	
	return true;
}

function Mutation_Tank_ClearZombies(%mini)
{
	%mini.zombieTank = "";
	%mini.zombieTankSpawnOn = "";
	return true;
}

function Mutation_Tank_Stress(%mini)
{
	// Hack to have the director always on rage mode to give the tank ultimate damage.
	return -1000 SPC 0;
}

function Mutation_Tank_Time(%mini)
{
	if(!isEventPending(%mini.zombieTank.zombieSpawnAsTankSched))
	{
		%name = %mini.zombieTank.name;
		
		if(%name $= "")
		{
			%name = "The Tank";
		}
		
		// Did we lose just now?
		if(%mini.zombieLastHumanCount != 0 && %mini.getNumberOfHumans() == 0)
		{
			%mini.zombieTimeLeftCd = %mini.ZAPT_Time_Reset;
			%mini.zombieGameLost = true;
		}
		
		// Mark how many are left...
		%mini.zombieLastHumanCount = %mini.getNumberOfHumans();
		
		if(isObject(%mini.zombieTank.player))
		{
			%hp = %mini.zombieTank.player.getDatablock().maxDamage - %mini.zombieTank.player.getDamageLevel();
			%hp += %mini.zombieTank.player.pseudoHealth;
			%hp = mFloor(%hp);
		}
		else
		{
			%hp = 0;
		}
		
		// Count down to reset/loss/victory.
		if(%mini.zombieLastHumanCount && %hp)
		{
			if(%mini.ZAPT_Timer)
			{
				%mini.zombieTimeLeft--;
			}
			
			%mini.zombieTimeLeftCd = %mini.ZAPT_Time_Reset;
			%mini.zombieGameLost = false;
		}
		else
		{
			%mini.zombieTimeLeftCd--;
			%mini.zombieGameLost = true;
		}
		
		// If (survivors and tank) OR (game is lost AND count-down time left)
		// Basically, is game still running/resetting?
		if((%mini.zombieLastHumanCount && %hp) || (%mini.zombieGameLost && %mini.zombieTimeLeftCd > 0))
		{
			if(%mini.zombieLastHumanCount && %hp)
			{
				for(%a = 0; %a < %mini.numMembers; %a++)
				{
					%member = %mini.member[%a];
					
					if(%member.isZombie)
					{
						%color = "<color:aaffaa>";
					}
					else
					{
						%color = "<color:ffaaaa>";
					}
					
					%rage = mFloor((%mini.zombieLastHumanCount - 1) / 4);
					
					switch(%rage)
					{
						case 0: %rage = "<color:ffffaa>Not Happy";
						case 1: %rage = "<color:ffaaaa>Irritated";
						case 2: %rage = "<color:ff8888>Pissed";
						case 3: %rage = "<color:ff4444>Enraged";
						default: %rage = "<color:ff0000>FURIOUS";
					}
					
					%member.bottomPrint("<color:ffffaa>" @ %name @ %color @ " has <color:ffffaa>" @ %hp @ " HP" @ %color @ " left and is" SPC %rage @ %color @ " at <color:ffffaa>" @ %mini.zombieLastHumanCount @ %color @" survivors!" , 1.25);
					
					if(isObject(%member.player))
					{
						%member.player.setShapeNameColor($MiniGameColorF[%mini.colorIdx] SPC "1");
					}
				}
			}
			else
			{
				%minutes = mFloor(%mini.zombieTimeLeftCd / 60);
				%seconds = %mini.zombieTimeLeftCd % 60;
				
				if(%minutes)
				{
					%timeString = %minutes @ " minute" @ (%minutes != 1 ? "s" : "") @ " and " @ %seconds @ " second" @ (%seconds != 1 ? "s" : "");
				}
				else
				{
					%timeString = %seconds @ " second" @ (%seconds != 1 ? "s" : "");
				}
				
				if(!%hp)
				{
					%mini.bottomPrintAll("<color:ffffaa>" @ %name @ "<color:ffaaaa> has died. Restarting minigame in " @ %timeString @ ".", 1.25);
				}
				else if(%mini.getNumberOfSurvivors() == %mini.numMembers)
				{
					%mini.bottomPrintAll("<color:aaffaa>Everyone was evacuated! Restarting minigame in " @ %timeString @ ".", 1.25);
				}
				else if(%mini.getNumberOfSurvivors() > 0)
				{
					%mini.bottomPrintAll("<color:ffaaaa>Everyone is dead or evacuated. Restarting minigame in " @ %timeString @ ".", 1.25);
				}
				else
				{
					%mini.bottomPrintAll("<color:ffaaaa>Everyone is dead. Restarting minigame in " @ %timeString @ ".", 1.25);
				}
			}
			
			cancel(%mini.zombieAnnounceTimeSched);
			%mini.zombieAnnounceTimeSched = %mini.schedule(1000, "announceTimeLeft");
		}
		else
		{
			if(!%hp)
			{
				%memberString = "";
				%deadString = "";
				
				for(%a = 0; %a < %mini.numMembers; %a++)
				{
					%member = %mini.member[%a];
					
					%survivor = false;
					
					if(isObject(%member.player) || %member.isRescued)
					{
						if(%memberString $= "")
						{
							%memberString = %member.name;
						}
						else
						{
							%memberString = %memberString @ ", " @ %member.name;
						}
					}
				}
				
				%mini.messageAll('', "<color:aaffaa>The following humans lived: \c3" @ %memberString);
			}
			else
			{
				%mini.messageAll('', "<color:ffffaa>" @ %name @ "<color:ffaaaa> kicked the humans' asses.");
			}
			
			cancel(%mini.zombieAnnounceTimeSched);
			%mini.reset(%mini.owner);
		}
	}
	else
	{
		%seconds = mFloor(%mini.zombieTankSpawnOn - $sim::time + 1);
		
		%timeString = %seconds @ " second" @ (%seconds != 1 ? "s" : "");
		
		%mini.bottomPrintAll("<color:ffaaaa>The Tank will arrive in " @ %timeString @ "!", 1.25);
	}
	
	return true;
}