// ============================================================
// Project				:	ZAPT
// Author				:	Iban
// Description			:	Zombie Source Code
// ============================================================
// Table of Contents
// 
// 1. Bitch
// 2. Consumer
// 3. Crawler
// 4. Fallen Survivor
// 5. Leaper
// 6. Jockey
// 7. Smasher
// 8. Smoker
// 9. Spitter
// 10. SWAT
// 11. Standard
// 12. Swimmer
// 13. Tank
// ============================================================

// ============================================================
// Section 1 : Bitch
// ============================================================
function ZombieBitchArmor::onNewDatablock(%this, %obj)
{
	parent::onNewDatablock(%this, %obj);
	
	if(isObject(%obj))
	{
		%obj.mountImage("ZombieClawRightImage", 0);
		%obj.mountImage("ZombieClawLeftImage", 1);
		
		%obj.zombieLight("ZombieWitchLight");
		
		if(zombieBot(%obj))
		{
			%obj.zombieWitchSitting = true;
			%obj.playThread(0, "sit");
		}
	}
}

function ZombieBitchArmor::onCollision(%this, %obj, %col, %pos, %vel)
{
	%result = parent::onCollision(%this, %obj, %col, %pos, %vel);
	%mini = getMiniGameFromObject(%obj);
	
	if(zombieGameSetUpRight(%mini))
	{
		if(zombieBot(%obj) && zombieValidTarget(%obj, %col))
		{
			if(%obj.zombieHasTarget() && %obj.target.getID() == %col.getID())
			{
				%obj.zombieClaw();
			}
			else if(%obj.zombieHasTarget() && %obj.target.getID() != %col.getID())
			{
				%oPos = %obj.getEyePoint();
				%tPos = %col.getEyePoint();
				
				if(!getRandom(0, 1))
				{
					%left = getWord(%fVec, 0);
					
					// Left
					if(%left + 1 > 1)
					{
						%leftNew = %left - 1;
					}
					else
					{
						%leftNew = %left + 1;
					}
					
					if(%right - 1 < -1)
					{
						%rightNew = %right + 1;
					}
					else
					{
						%rightNew = %right - 1;
					}
					
					%vec = %leftNew SPC %rightNew SPC "0";
				}
				else
				{
					// Right
					%right = getWord(%fVec, 1);
					
					if(%left - 1 < -1)
					{
						%leftNew = %left + 1;
					}
					else
					{
						%leftNew = %left - 1;
					}
					
					if(%right + 1 > 1)
					{
						%rightNew = %right - 1;
					}
					else
					{
						%rightNew = %right + 1;
					}
					
					%vec = %leftNew SPC %rightNew SPC "0"; 
				}
				
				%col.applyImpulse(%col.getPosition(), vectorScale(%vec, 5));
			}
			else if(!%obj.zombieHasTarget())
			{
				%obj.zombieChase(%col);
				%obj.zombieClaw();
			}
		}
	}
	
	return %result;
}

function ZombieBitchArmor::zombieChase(%this, %obj, %target)
{
	if(isObject(%obj) && !%obj.zombieHadTarget && isObject(%target))
	{
		if(zombieValidTarget(%obj, %target) && %target.getType() & $TypeMasks::PlayerObjectType)
		{
			%obj.zombieDecalFace = "WitchAngry";
			%obj.setFaceName(%obj.zombieDecalFace);
			
			%result = parent::zombieChase(%this, %obj, %target);
			
			if(%result)
			{
				%obj.zombieHadTarget = true;
				%obj.playThread(0, "root");
				%obj.setMoveY(true);
			}
			
			return %result;
		}
	}
	
	return false;
}

function ZombieBitchArmor::zombieConsume(%this, %obj, %col)
{
	if(zombieValidTarget(%obj, %col))
	{
		// Energy
		%energy = %obj.getEnergyLevel();
		
		if(%energy > 6.5 && $sim::time - %obj.zombieLastClaw > 0.1)
		{
			%obj.setEnergyLevel(%energy - 6.5);
			%obj.zombieLastClaw = $sim::time;
			
			%pos = %obj.getPosition();
			%damage = %obj.getDatablock().zombieDamage;
			%damage = mDirMod(%damage * 0.60, %damage * 1.30, getMiniGameFromObject(%obj));
			%damage *= (zombieBot(%obj) ? 0.75 : 1);
			%damage *= ($sim::time - %obj.zombieLastClawDamage >= 1 ? 1 : $sim::time - %obj.zombieLastClawDamage);
			%damage = mCeil(%damage);
			
			if(%this.zombieDamType !$= "")
			{
				%damageType = %this.zombieDamType;
			}
			else
			{
				%damageType = $DamageType::Zombies;
			}
			
			%col.damage(%obj, %pos, %damage, %damageType);
			%obj.zombieLastClawDamage = $sim::time;
			
			%dif = vectorSub(%col.getPosition(), %obj.getPosition());
			%col.setVelocity(vectorAdd(%col.getVelocity(), vectorScale(%dif, -1.5)));
			
			if(!zombieBot(%obj))
			{
				commandToClient(%obj.client, 'centerPrint', "<font:impact:32>*SLASH*\n<font:impact:16>Fuck.  You.  And.  Die.", 2);
			}
			else if(!isObject(%col) || %col.getType() & $TypeMasks::CorpseObjectType)
			{
				%obj.target = 0;
				%obj.setAimObject(-1);
				%obj.setMoveObject(-1);
				%obj.setMoveY(false);
				
				%this.schedule(3000, "zombieGoHome", %obj);
			}
			
			return true;
		}
	}
	
	return false;
}

function ZombieBitchArmor::zombieDeath(%this, %obj, %objClient, %sourceObject, %sourceClient, %bot, %pos, %damage, %damageType)
{
	if(isObject(%obj.light))
	{
		%obj.light.delete();
	}
	
	return parent::zombieDeath(%this, %obj, %objClient, %sourceObject, %sourceClient, %bot, %pos, %damage, %damageType);
}

function ZombieBitchArmor::zombieDress(%this, %obj)
{
	if(zombieBot(%obj)) //!isObject(%obj.zombieClothedAs) || %obj.zombieClothedAs.getID() != %this.getID())
	{
		// Blob Data
		%obj.zombieClothedAs = %this.getID();
		%obj.zombieDecalChest = "ZAPT-Witch";
		%obj.zombieDecalFace = "WitchFace";
		%obj.zombieHat = 0;
		%obj.zombieGarmentCount = 9;
		%obj.zombieGender = 1;
		%obj.zombieSkinColor = %this.getSkinColor(%obj);
		
		// Nudity
		for(%a = 0; %a < 9; %a++)
		{
			switch(%a)
			{
				case 0: %garment = $Hat[%obj.zombieHat];
				case 1: %garment = $Chest[%obj.zombieGender];
				case 2: %garment = $LArm[%obj.zombieGender];
				case 3: %garment = $RArm[%obj.zombieGender];
				case 4: %garment = "lhand";
				case 5: %garment = "rhand";
				case 6: %garment = "pants";
				case 7: %garment = "lshoe";
				case 8: %garment = "rshoe";
			}
			
			%color = "skin";
			
			%obj.zombieGarment[%a] = %garment;
			%obj.zombieGarmentColor[%a] = %color;
		}
	}
	else
	{
		%obj.zombieClothedAs = %this.getID();
		%obj.zombieDecalFace = "WitchFace";
		
		%obj.hideNode($Chest[0]);
		%obj.unHideNode($Chest[1]);
		%obj.hideNode($LArm[0]);
		%obj.unHideNode($LArm[1]);
		%obj.hideNode($RArm[0]);
		%obj.unHideNode($RArm[1]);
	}
	
	return false;
}

function ZombieBitchArmor::zombieGetTarget(%this, %obj)
{
	if(%obj.isZombie)
	{
		%mini = getMiniGameFromObject(%obj);
		
		if(zombieGameSetUpRight(%mini))
		{
			%pos = %obj.getPosition();
			
			%topAnger = 0;
			%topMember = "";
			
			for(%a = 0; %a < %mini.numMembers; %a++)
			{
				%member = %mini.member[%a].player;
				
				if(zombieValidTarget(%obj, %member))
				{
					%memPos = %member.getPosition();
					%dist = vectorDist(%pos, %memPos);
					
					if(%dist <= 8)
					{
						%anger = 0;
						%factor = 8 / %dist;
						
						if(%factor > 2)
						{
							%factor = 2;
						}
						
						if($sim::time - %member.zombieNoiseMake < 3)
						{
							%anger += 20;
						}
						
						if(isObject(%member.light))
						{
							%anger += 20;
						}
						
						%fVec = %member.getForwardVector();
						%norm = vectorNormalize(vectorSub(%pos, %memPos));
						%normDif = vectorAdd(%fVec, %norm);
						%normPow = 0;
						
						if(getWord(%normDif, 0) < 0)
						{
							%normPow += -getWord(%normDif, 0);
						}
						else
						{
							%normPow += getWord(%normDif, 0);
						}
						
						if(getWord(%normDif, 1) < 0)
						{
							%normPow += -getWord(%normDif, 1);
						}
						else
						{
							%normPow += getWord(%normDif, 1);
						}
						
						%normPow -= 2;
						
						if(%normPow < 0)
						{
							%normPow = 0;
						}
						
						%anger += 40 * %normPow;
						
						%anger *= %factor;
						
						if(%anger > %topAnger)
						{
							%topAnger = %anger;
							%topMember = %member;
						}
					}
				}
			}
			
			if(isObject(%topMember))
			{
				if(%topAnger >= 65)
				{
					return %topMember;
				}
				else if(%topAnger >= 25 && %obj.zombieWitchSitting)
				{
					%obj.playThread(0, "root");
					%obj.setAimObject(%topMember);
					%obj.zombieWitchSitting = false;
				}
			}
			
			if(!%obj.zombieWitchSitting && isObject(%obj.getAimObject()) && !isObject(%topMember) && %topAnger < 25)
			{
				%obj.playThread(0, "sit");
				%obj.clearAim();
				%obj.zombieWitchSitting = true;
			}
		}
	}
	
	return 0;
}

function ZombieBitchArmor::zombieGoHome(%this, %obj)
{
	if(isObject(%obj))
	{
		%obj.spawnExplosion("playerTeleportProjectile", getWord(%obj.getScale(), 2));
		%obj.delete();
	}
}	

function ZombieBitchArmor::zombieSee(%this, %obj, %target)
{
	if(%this.isZombieArmor && isObject(%target) && %obj.zombieHasTarget())
	{
		%mainTarget = %obj.target;
		
		if(isObject(%mainTarget) && %mainTarget.getID() ==  %target.getID())
		{
			return true;
		}
	}
	
	return false;
}

function ZombieBitchArmor::zombieWander(%this, %obj)
{
	return false;
}

// ============================================================
// Section 2 : Consumer
// ============================================================
function ZombieConsumerArmor::onDisabled(%this, %obj)
{
	%this.zombieExplode(%obj);
	return parent::onDisabled(%this, %obj);
}

function ZombieConsumerArmor::zombieAdjustSize(%this, %obj)
{
	%size = "1.0 1.0 1.0";
	%maxS = "1.4 1.4 1.4";
	%incs = vectorScale(vectorSub(%maxS, %size), %obj.zombieConsumedFlesh / 20);
	%size = vectorAdd(%size, %incs);
	
	%obj.setScale(%size);
}

function ZombieConsumerArmor::zombieConsume(%this, %obj, %col)
{
	%result = parent::zombieConsume(%this, %obj, %col);
	
	if(%result)
	{
		if(%obj.zombieConsumedFlesh < 20)
		{
			%obj.zombieConsumedFlesh++;
			%this.zombieAdjustSize(%obj);
		}
		
		%percent = (%obj.zombieConsumedFlesh / 20) * 100;
		
		if(!zombieBot(%obj))
		{
			commandToClient(%obj.client, 'centerPrint', "<just:right><font:impact:32><color:aaffaa>Stomach" SPC %percent @ "% Full", 0.5);
		}
	}
	
	return %result;
}

function ZombieConsumerArmor::zombieExplode(%this, %obj)
{
	%p = new projectile()
	{
		dataBlock = "ZombieBeaconProjectile";
		initialVelocity = 0;
		initialPosition = %obj.zombieMidPoint();
		sourceObject = %obj;
		sourceSlot = $WeaponSlot;
		client = %obj.client;
	};
	
	%p.setScale(%obj.getScale());
	%p.explode();
	
	return true;
}

function ZombieConsumerArmor::zombieSpecial(%this, %obj)
{
	if($sim::time - %obj.zombieVomitTime > 0.5)
	{ 
		if(%obj.zombieConsumedFlesh)
		{
			%obj.spawnProjectile(50, "ZombieBileProjectile", "1 1 1", 1);
			
			%obj.zombieVomitTime = $sim::time;
			%obj.zombieConsumedFlesh--;
			%this.zombieAdjustSize(%obj);
			
		}
		
		%percent = (%obj.zombieConsumedFlesh / 20) * 100;
		
		if(!zombieBot(%obj))
		{
			commandToClient(%obj.client, 'centerPrint', "<just:right><font:impact:32><color:ffaaaa>Stomach" SPC %percent @ "% Full", 1);
		}
	}
}

// ============================================================
// Section 3 : Crawler
// ============================================================
// I made you a crawler, but I eated it.

// ============================================================
// Section 4 : Fallen Survivor
// ============================================================
function ZombieFallenArmor::getSkinColor(%this, %obj)
{
	// Louis gets what I have determined is a zombified black person skincolor.
	if(%obj.zombieDecalChest == 2)
	{
		return "0.392 0.196 0.200 1.000";
	}
	else
	{
		return parent::getSkinColor(%this, %obj);
	}
}

function ZombieFallenArmor::zombieDeath(%this, %obj, %objClient, %sourceObject, %sourceClient, %bot, %pos, %damage, %damageType)
{
	%mini = getMiniGameFromObject(%sourceClient);
	
	if(zombieGameSetUpRight(%mini))
	{
		switch(getRandom(0, 3))
		{
			case 0: %db = "ZombieBileItem";
			case 1: %db = "ZombieMedpackItem";
			case 2: %db = "ZombieMolotovItem";
			case 3: %db = "ZombiePillsItem";
			default: %db = "ZombiePipebombItem";
		}
		
		if(!isObject(%db))
		{
			%db = "ZombiePillsItem";
		}
		
		if(isObject(%db))
		{
			%fvec = %obj.getForwardVector();
			%fX = getWord(%fvec,0);
			%fY = getWord(%fvec,1);
			
			%evec = %obj.getEyeVector();
			%eX = getWord(%evec,0);
			%eY = getWord(%evec,1);
			%eZ = getWord(%evec,2);
			
			%eXY = mSqrt(%eX * %eX + %eY * %eY);
			
			%aimVec = %fX * %eXY SPC %fY * %eXY SPC %eZ;
			
			%rot = rotFromTransform(%obj.getTransform());
			%rot = getWords(%rot, 0, 2) SPC (getWord(%rot, 3) * 180 / $pi);
			
			%item = new Item()
			{
				canSetIFLs	= false;
				collideable	= false;
				dataBlock	= %db;
				position	= vectorAdd(%obj.getHackPosition(), vectorScale(%aimVec, 2));
				rotate		= false;
				rotation	= %rot;
				scale		= "1 1 1";
				static		= false;
				
				bl_id		= %mini.owner.bl_id;
				canpickup	= true;
				minigame	= %mini;
			};
			
			%item.setTransform(setWord(%obj.getTransform(), 2, getWord(%obj.getTransform(), 2) + 2));
			%item.setVelocity(vectorScale(%aimVec, 10));
			
			MissionCleanup.add(%item);
			
			%item.schedulePop();
		}
	}
	
	return parent::zombieDeath(%this, %obj, %objClient, %sourceObject, %sourceClient, %bot, %pos, %damage, %damageType);
}

function ZombieFallenArmor::zombieDress(%this, %obj)
{
	if(!isObject(%obj.zombieClothedAs) || %obj.zombieClothedAs.getID() != %this.getID())
	{
		%obj.zombieClothedAs	= %this.getID();
		%obj.zombieDecalChest	= getRandom(0, 3);
		%obj.zombieDecalFace	= getRandom(0, 7);
		%obj.zombieGarmentCount	= 9;
		%obj.zombieSkinColor	= %this.getSkinColor(%obj);
		
		switch(%obj.zombieDecalChest)
		{
			case 0:
				%obj.zombieHat = 6;
				%obj.zombieGender = 0;
				
				%color[0] = "0.000 0.400 0.200 1.000";
				%color[1] = "0.000 0.400 0.200 1.000";
				%color[2] = "0.000 0.400 0.200 1.000";
				%color[3] = "0.000 0.400 0.200 1.000";
				%color[4] = "skin";
				%color[5] = "skin";
				%color[6] = "0.200 0.200 0.200 1.000";
				%color[7] = "0.200 0.200 0.200 1.000";
				%color[8] = "0.200 0.200 0.200 1.000";
			case 1:
				%obj.zombieHat = 0;
				%obj.zombieGender = 0;
				
				%color[0] = "0.000 0.000 0.000 0.000";
				%color[1] = "0.200 0.200 0.200 1.000";
				%color[2] = "skin";
				%color[3] = "skin";
				%color[4] = "skin";
				%color[5] = "skin";
				%color[6] = "0.200 0.200 0.200 1.000";
				%color[7] = "0.200 0.200 0.200 1.000";
				%color[8] = "0.200 0.200 0.200 1.000";
			case 2:
				%obj.zombieHat = 0;
				%obj.zombieGender = 0;
				
				%color[0] = "0.000 0.000 0.000 0.000";
				%color[1] = "0.900 0.900 0.900 1.000";
				%color[2] = "0.900 0.900 0.900 1.000";
				%color[3] = "0.900 0.900 0.900 1.000";
				%color[4] = "skin";
				%color[5] = "skin";
				%color[6] = "0.200 0.200 0.200 1.000";
				%color[7] = "0.200 0.200 0.200 1.000";
				%color[8] = "0.200 0.200 0.200 1.000";
			case 3:
				%obj.zombieHat = 0;
				%obj.zombieGender = 1;
				
				%color[0] = "0.000 0.000 0.000 0.000";
				%color[1] = "0.900 0.000 0.000 1.000";
				%color[2] = "0.900 0.000 0.000 1.000";
				%color[3] = "0.900 0.000 0.000 1.000";
				%color[4] = "skin";
				%color[5] = "skin";
				%color[6] = "0.200 0.200 0.200 1.000";
				%color[7] = "0.392 0.196 0.000 1.000";
				%color[8] = "0.392 0.196 0.000 1.000";
			
			default: %obj.zombieHat = getRandom(0, 7); %obj.zombieGender = getRandom(0, 1);
		}
		
		// Tie-Dye
		for(%a = 0; %a < 9; %a++)
		{
			switch(%a)
			{
				case 0: %garment = $Hat[%obj.zombieHat];
				case 1: %garment = $Chest[%obj.zombieGender];
				case 2: %garment = $LArm[%obj.zombieGender];
				case 3: %garment = $RArm[%obj.zombieGender];
				case 4: %garment = "lhand";
				case 5: %garment = "rhand";
				case 6: %garment = "pants";
				case 7: %garment = "lshoe";
				case 8: %garment = "rshoe";
			}
			
			if(%color[%a] !$= "")
			{
				%color = %color[%a];
			}
			else
			{
				if(%a != 4 && %a != 5 && (%a == 0 || %a == 1 || %a == 6 || getRandom(0, 1)))
				{
					%color = (getRandom(50, 100) / 255) SPC (getRandom(50, 100) / 255) SPC (getRandom(50, 100) / 255) SPC "1";
				}
				else
				{
					%color = "skin";
				}
			}
			
			%obj.zombieGarment[%a] = %garment;
			%obj.zombieGarmentColor[%a] = %color;
		}
		
		// Face Paint
		switch(%obj.zombieDecalFace)
		{
			case 0: %obj.zombieDecalFace = "ZombieFaceA";
			case 1: %obj.zombieDecalFace = "ZombieFaceB";
			case 2: %obj.zombieDecalFace = "ZombieFaceC";
			case 3: %obj.zombieDecalFace = "ZombieFaceD";
			case 4: %obj.zombieDecalFace = "ZombieFaceE";
			case 5: %obj.zombieDecalFace = "ZombieFaceF";
			case 6: %obj.zombieDecalFace = "ZombieFaceG";
			case 7: %obj.zombieDecalFace = "ZombieFaceI";
			default: %obj.zombieDecalFace = "smiley";
		}
		
		// Chest Hairs
		switch(%obj.zombieDecalChest)
		{
			case 0: %obj.zombieDecalChest = "Survivor-Bill";
			case 1: %obj.zombieDecalChest = "Survivor-Francis";
			case 2: %obj.zombieDecalChest = "Survivor-Louis";
			case 3: %obj.zombieDecalChest = "Survivor-Zoey";
			default: %obj.zombieDecalChest = "AAA-None";
		}
		
		// We return a boolean representing "do you want to continue the parent function?"
		return false;
	}
	
	return true;
}

function ZombieFallenArmor::zombieSpecial(%this, %obj)
{
	return %obj.zombieSmash();
}

// ============================================================
// Section 5 : Leaper
// ============================================================
function ZombieLeaperArmor::onCollision(%this, %obj, %col, %pos, %vel)
{
	if(%vel > 12 && zombieValidTarget(%obj, %col))
	{
		%dist = mCeil(vectorDist(%obj.zombieLeapPos, %obj.getPosition()));
		%mini = getMiniGameFromObject(%obj);
		
		if(%obj.zombieOnFire())
		{
			%damagetype = $DamageType::BurningLeaper;
			
			%damage = mFloor(%vel * 0.862) * mFloor(%dist / 22);
			%damage = (zombieGameSetUpRight(%mini) ? mDirMod(%damage * 0.75, %damage * 1.25, %mini) : %damage);
			%damage = mFloor(%damage);
			
			if(%damage > 75)
			{
				%damage = 75;
			}
		}
		else
		{
			%damagetype = $DamageType::LeaperJump;
			
			%damage = mFloor(%vel * 0.475) * mFloor(%dist / 18);
			%damage = (zombieGameSetUpRight(%mini) ? mDirMod(%damage * 0.5, %damage * 1.0, %mini) : %damage);
			%damage = mFloor(%damage);
			
			if(%damage > 50)
			{
				%damage = 50;
			}
		}
		
		if(%damage > 0)
		{
			
			if(%damage >= 15 && !zombieBot(%col))
			{
				%usedTool = %col.currTool;
				
				if(%usedTool == -1)
				{
					for(%a = 0; %a < 10; %a++)
					{
						if(isObject(%col.tool[%a]))
						{
							%usedTool = %a;
							break;
						}
					}
				}
				
				if(%usedTool != -1)
				{
					serverCmdDropTool(%col.client, %usedTool);
					%obj.playThread(0, 'root');
					commandToClient(%col.client, 'centerPrint', "<font:impact:32>*POUNCED*\n<font:impact:16>A Leaper caused you to drop your weapon!!", 2.5);
					
					if(!zombieBot(%obj))
					{
						commandToClient(%obj.client, 'centerPrint', "<font:impact:32>*CRUNCH*\n<font:impact:16>" @ %damage @ " damage + weapon lost!", 1.5);
					}
				}
				else if(!zombieBot(%obj))
				{
					commandToClient(%obj.client, 'centerPrint', "<font:impact:32>*CRUNCH*\n<font:impact:16>" @ %damage @ " damage!", 1.5);
				}
			}
			else if(!zombieBot(%obj))
			{
				commandToClient(%obj.client, 'centerPrint', "<font:impact:32>*CRUNCH*\n<font:impact:16>" @ %damage @ " damage!", 1.5);
			}
			
			serverPlay3D(ZombieCrunchSound, %pos);
			%col.damage(%obj, %pos, %damage, %damagetype);
		}
	}
	
	return parent::onCollision(%this, %obj, %col, %pos, %vel);
}

function ZombieLeaperArmor::onImpact(%this, %obj, %col, %vel, %z)
{
	return parent::onImpact(%this, %obj, %col, %vel, %z);
}

function ZombieLeaperArmor::zombieDetectRoute(%this, %obj, %canSee, %dist, %reach, %zDist, %hCol, %lCol, %hHit, %lhit, %fhit)
{
	if(%canSee && %dist > (%reach * 3) && %obj.getEnergyLevel() >= 50)
	{
		return "special";
	}
	else
	{
		return parent::zombieDetectRoute(%this, %obj, %canSee, %dist, %reach, %zDist, %hCol, %lCol, %hHit, %lhit, %fhit);
	}
}

function ZombieLeaperArmor::zombieSpecial(%this, %obj)
{
	%energy = %obj.getEnergyLevel();
	
	if(%obj.isCrouched() || zombieBot(%obj))
	{
		if(%energy >= 50)
		{
			%start = %obj.getPosition();
			%end = vectorSub(%start, "0 0 2");
			%masks = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
			
			%ground = getWord(containerRayCast(%start, %end, %masks, %obj), 0);
			
			if(isObject(%ground))
			{
				%canJump = true;
			}
			else
			{
				%end = vectorSub(%start, %obj.getForwardVector());
				%ground = getWord(containerRayCast(%start, %end, %masks, %obj), 0);
				
				if(isObject(%ground))
				{
					%canJump = true;
				}
			}
			
			if(%canJump)
			{
				%aimVec = %obj.zombieAimVec();
				%obj.setVelocity(vectorScale(%aimVec, 40));
				
				%obj.setEnergyLevel(%energy - 50);
				%obj.playThread(2, "jump");
				
				%obj.zombieLeapPos = %obj.getPosition();
				
				return true;
			}
		}
	}
	else
	{
		commandToClient(%obj.client, 'centerPrint', "<font:impact:16>Crouch before Jumping", 1.5);
	}
	
	return false;
}

// ============================================================
// Section 6 : Jockey
// ============================================================
function ZombieJockeyArmor::doDismount(%this, %obj)
{
	// Sometimes mounting process is buggy and people can
	// auto-dismount. This helps with that.
	if(!%Obj.zombieRiding)
	{
		return parent::doDismount(%this, %obj);
	}
}

function ZombieJockeyArmor::onCollision(%this, %obj, %col, %pos, %vel)
{
	if(%vel >= 7.5 && zombieValidTarget(%obj, %col) && !zombieBot(%col) && !isObject(%obj.getObjectMount()) && !isObject(%col.getObjectMount()))
	{
		if(!%col.isZombie && !%col.zombieBeingRidden && !isObject(%col.getObjectMount()) && !%col.zombieSmoked)
		{
			%col.emote(AlarmProjectile);
			%col.mountObject(%obj, $HeadSlot);
			%col.unMountImage($WeaponSlot);
			%col.playThread(0, "root");
			%col.playThread(1, "root");
			%col.playThread(2, "root");
			
			if(!zombieBot(%col))
			{
				switch(getRandom(0, 4))
				{
					case 0: %message = "What is this thing doing to my face?";
					case 1: %message = "Something's sitting on my head!";
					case 2: %message = "Get it off! Get it off! GET IT OFF.";
					case 3: %message = "Can someone MAYBE shoot this thing on me?!";
					case 4:
						if(%col.client.chest)
							%message = "No means NO! Arrgggh";
						else
							%message = "No man deserves to be ridden like this!";
				}
				
				%col.client.zombieHelp(%message, true);
				serverCmdUnUseTool(%col.client);
			}
			
			%obj.playThread(0, "sit");
			
			%col.zombieHelpless = true;
			%col.zombieBeingRidden = true;
			%col.zombieBeingRiddenBy = %obj.getID();
			%obj.zombieRiding = true;
			%obj.zombieRidingWho = %col.getID();
			%obj.zombieRidingSince = $sim::time;
			
			%this.zombieAutoSlap(%obj);
			
			%hide[%hiding++] = "LShoe";
			%hide[%hiding++] = "RShoe";
			%hide[%hiding++] = "LPeg";
			%hide[%hiding++] = "RPeg";
			%hide[%hiding++] = "skirtHip";
			%hide[%hiding++] = "skirtTrimLeft";
			%hide[%hiding++] = "skirtTrimRight";
			
			for(%a = 1; %a < %hiding; %a++)
			{
				%obj.hideNode(%hide[%a]);
			}
			
			%obj.unHideNode("pants");
		}
	}
	
	return parent::onCollision(%this, %obj, %col, %pos, %vel);
}

function ZombieJockeyArmor::onUnMount(%this, %obj, %mount, %idk)
{
	%obj.zombieJockeyDismount();
	
	if(isObject(%mount))
	{
		%mount.zombieJockeyDismount();
	}
	
	return parent::onUnMount(%this, %obj, %mount, %idk);
}

function ZombieJockeyArmor::zombieAutoSlap(%this, %obj)
{
	%victim = %obj.zombieRidingWho;
	
	if(zombieValidTarget(%obj, %victim) && isObject(%obj.getObjectMount()) && %obj.getObjectMount().getID() == %victim.getID())
	{
		%damage = mDirMod(3, 6, getMiniGameFromObject(%obj));
		
		%victim.damage(%obj, %obj.getPosition(), %damage, $DamageType::JockeyRide);
		
		if(%obj.getState() !$= "Dead" && %victim.getState() !$= "Dead")
		{
			%obj.zombieJockeyDamageTime = $sim::time;
			
			if(!zombieBot(%obj))
			{
				%rand = getRandom(0, 4);
				
				switch(%rand)
				{
					case 0: %tagline = "Hehe! Ehehe";
					case 1: %tagline = "Hehehehe";
					case 2: %tagline = "Eheh... hehehe";
					case 3: %tagline = "Ehehehe";
					case 4: %tagline = "Ehehee, hehehehee";
					default: %tagline = "Error Rand for" SPC %rand;
				}
				
				commandToClient(%obj.client, 'centerPrint', "<font:impact:32>*SLAP*\n<font:impact:16>" @ %tagline @ "!", 1.5);
			}
			
			if(!zombieBot(%victim))
			{
				%rand = getRandom(0, 4);
				
				switch(%rand)
				{
					case 0: %tagline = "Jockey.. jockey";
					case 1: %tagline = "Get this jockey off me";
					case 2: %tagline = "Get this thing off of my head";
					case 3: %tagline = "What is this thing doing to my face";
					case 4: %tagline = "Oh lord no";
					default: %tagline = "Error Rand for" SPC %rand;
				}
				
				commandToClient(%victim.client, 'centerPrint', "<font:impact:32>*SLAPPED*\n<font:impact:16>" @ %tagline @ "!", 1.5);
				
				if(!zombieBot(%obj) && !ZombieFriends.isFriend(%obj.client, %victim.client))
				{
					%bars = "<color:aaffaa>";
					%div = 20;
					%tens = mCeil(%victim.getDamagePercent() * %div);
					
					for(%a = 0; %a < %div; %a++)
					{
						if(%a == (%div - %tens))
						{
							%bars = %bars @ "<color:ffaaaa>";
						}
						
						%bars = %bars @ "|";
					}
					
					commandToClient(%obj.client, 'centerPrint', %bars, 1.25);
				}
			}
			
			cancel(%obj.zombieJockeyAutoslapSched);
			%obj.zombieJockeyAutoslapSched = %this.schedule(1000, "zombieAutoSlap", %obj);
		}
	}
	else
	{
		cancel(%obj.zombieJockeyAutoslapSched);
		%obj.zombieJockeyDismount();
		
		if(isObject(%victim))
		{
			%victim.zombieJockeyDismount();
		}
	}
}

function ZombieJockeyArmor::zombieClaw(%this, %obj)
{
	if(!%obj.zombieRiding)
	{
		return parent::zombieClaw(%this, %obj);
	}
	
	return false;
}

function ZombieJockeyArmor::zombieDeath(%this, %obj, %objClient, %sourceObject, %sourceClient, %bot, %pos, %damage, %damageType)
{
	%victim = %obj.zombieRidingWho;
	
	if(isObject(%victim))
	{
		if(!zombieBot(%sourceClient))
		{
			if(!zombieBot(%victim.client))
			{
				messageClient(%sourceClient, '', "<color:aaffaa>You rescued \c3" @ %victim.client.name @ "<color:aaffaa>!");
			}
			else
			{
				messageClient(%sourceClient, '', "<color:aaffaa>You rescued \c3a survivor<color:aaffaa>!");
			}
		}
		
		if(!zombieBot(%victim.client))
		{
			if(!zombieBot(%sourceClient))
			{
				messageClient(%victim.client, '', "<color:aaffaa>You were rescued by \c3" @ %sourceClient.name @ "<color:aaffaa>!");
			}
			else
			{
				messageClient(%victim.client, '', "<color:aaffaa>You were rescued<color:aaffaa>!");
			}
		}
	}
	
	%obj.zombieJockeyDismount();
	
	return parent::zombieDeath(%this, %obj, %objClient, %sourceObject, %sourceClient, %bot, %pos, %damage, %damageType);
}

function ZombieJockeyArmor::zombieDetectRoute(%this, %obj, %canSee, %dist, %reach, %zDist, %hCol, %lCol, %hHit, %lhit, %fhit)
{
	if(%obj.zombieRiding && isObject(%obj.zombieRidingWho))
	{
		%aimVec = %obj.zombieRidingWho.zombieAimVec();
		%aimLoc = vectorAdd(%obj.zombieRidingWho.getPosition(), vectorScale(%aimVec, 5));
		%aimLoc = getWords(%aimLoc, 0, 1) SPC vectorAdd(getWord(%obj.zombieRidingWho.getPosition(), 2), 3);
		
		%obj.setAimObject(-1);
		%obj.setAimLocation(%aimLoc);
		
		return "special";
	}
	else if(%canSee && %dist <= 8 && %zDist < 1 && %zDist > -1 && !%lHit && !%hHit)
	{
		return "special";
	}
	else
	{
		return parent::zombieDetectRoute(%this, %obj, %canSee, %dist, %reach, %zDist, %hCol, %lCol, %hHit, %lhit, %fhit);
	}
}

function ZombieJockeyArmor::zombieSpecial(%this, %obj)
{
	%energy = %obj.getEnergyLevel();
	
	if(%energy >= 15)
	{
		%mount = %obj.getObjectMount();
		
		if(!isObject(%mount))
		{
			%start = %obj.getPosition();
			%end = vectorSub(%start, "0 0 1");
			%masks = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
			
			%ground = getWord(containerRayCast(%start, %end, %masks, %obj), 0);
			
			if(isObject(%ground))
			{
				%aimVec = %obj.zombieAimVec();
				%obj.setVelocity(vectorScale(%aimVec, 18));
				
				%obj.setEnergyLevel(%energy - 15);
				%obj.playThread(2, "jump");
				
				return true;
			}
		}
		else if(%energy >= 50)
		{
			%start = %mount.getPosition();
			%end = vectorSub(%start, "0 0 1");
			%masks = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
			
			%ground = getWord(containerRayCast(%start, %end, %masks, %obj), 0);
			
			if(isObject(%ground))
			{
				%aimVec = %obj.zombieAimVec();
				%mount.setVelocity(vectorScale(%aimVec, 12));
				
				%obj.setEnergyLevel(%energy - 35);
				%mount.playThread(2, "jump");
				
				return true;
			}
		}
	}
	
	return false;
}

// ============================================================
// Section 7 : Smasher
// ============================================================
function ZombieSmasherArmor::onNewDatablock(%this, %obj)
{
	parent::onNewDatablock(%this, %obj);
	
	if(isObject(%obj))
	{
		%obj.mountImage("ZombieFistSmasherImage", 0);
	}
}

function ZombieSmasherArmor::zombieClaw(%this, %obj)
{
	%obj.zombieSmash();
	return parent::zombieClaw(%this, %obj);
}

function ZombieSmasherArmor::zombieDetectRoute(%this, %obj, %canSee, %dist, %reach, %zDist, %hCol, %lCol, %hHit, %lhit, %fhit)
{
	// If we can see, and we can reach, and we're level, AND we have no obstructions... Chaaaaarrge!
	if(%canSee && %dist > %reach && %zDist < 1 && %zDist > -1 && !%lHit && !%hHit)
	{
		// You have to give it time to turn or it will just dart off into the middle of god knows where.
		%this.schedule(250, "zombieSpecial", %obj);
		return "";
	}
	else
	{
		return parent::zombieDetectRoute(%this, %obj, %canSee, %dist, %reach, %zDist, %hCol, %lCol, %hHit, %lhit, %fhit);
	}
}

function ZombieSmasherArmor::zombieSpecial(%this, %obj)
{
	if(isObject(%obj) && !%obj.isCrouched())
	{
		%start = %obj.getPosition();
		%end = vectorSub(%start, "0 0 1");
		%masks = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
		
		%ground = getWord(containerRayCast(%start, %end, %masks, %obj), 0);
		
		if(isObject(%ground))
		{
			%start = %obj.getEyePoint();
			%aimVec = %obj.zombieAimVec();
			%end = vectorAdd(%start, vectorScale(%aimVec, 3));
			%masks = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
			
			%wall = getWord(containerRayCast(%start, %end, %masks, %obj), 0);
			
			if(!isObject(%wall))
			{
				%energy = %obj.getEnergyLevel();
				
				if(%energy >= 80)
				{
					%obj.changeDatablock(ZombieSmasherChargingArmor);
					%this.zombieCameraSpectate(%obj);
					
					%conn = new AIConnection()
					{
						bl_id = 1337;
						connected = true;
						hasSpawnedOnce = false;
						name = "Prosmasher666";
						zombieSmasherAI = true;
					};
					
					MissionCleanup.add(%conn);
					
					%conn.setControlObject(%obj);
					%conn.setMove("y", true);
					%obj.zombieChargerConn = %conn;
					%obj.zombieChargingSched = ZombieSmasherChargingArmor.schedule(250, "zombieSlowDownCheck", %obj, %conn);
					%obj.zombieChargerStart = %obj.getPosition();
					%obj.zombieChargerStartTime = $sim::time;
					
					return true;
				}
			}
		}
	}
	
	return false;
}

function ZombieSmasherChargingArmor::Damage(%this, %obj, %sourceObject, %pos, %damage, %damageType)
{
	if(%damage + %obj.getDamageLevel() < %this.maxDamage)
	{
		%damage = mFloor(%damage / 1.5);
	}
	
	if(%damage > 0)
	{
		return parent::Damage(%this, %obj, %sourceObject, %pos, %damage, %damageType);
	}
}

function ZombieSmasherChargingArmor::onCollision(%this, %obj, %col, %pos, %vel)
{
	if(isObject(%obj) && %obj.getState() !$= "Dead" && %vel > 1.5)
	{
		%className = %col.getClassName();
		
		// Bot & Human Ellimination
		if((%className $= "Player" || %className $= "AIPlayer") && %col.getState() !$= "Dead")
		{
			%damage = 0;
			
			if(%col.isZombie && zombieSameGame(%obj, %col))
			{
				%damage = 100;
			}
			else if(!%col.isZombie && zombieValidTarget(%obj, %col))
			{
				%damage = mCeil(%vel / 6) * 6;
				%damage = zombieGameSetUpRight(%mini) ? mDirMod(%damage * 0.75, %damage * 1.50, %mini) : %damage;
				
				if(%damage < 10)
				{
					%damage = 10;
				}
			}
			
			if(%damage > 0)
			{
				%col.lastPusher = zombieBot(%obj) ? %obj : %obj.client;
				%col.addVelocity(vectorAdd(vectorScale(%obj.getForwardVector(), %vel / 1.5), "0 0" SPC %vel / 2));
				%col.schedule(32, "damage", %obj, %pos, %damage, $DamageType::SmasherRam);
				serverPlay3D(ZombieCrunchSound, %pos);
			}
			else
			{
				%obj.setEnergyLevel(0);
			}
		}
	}
}

function ZombieSmasherChargingArmor::onNewDatablock(%this, %obj)
{
	parent::onNewDatablock(%this, %obj);
	
	if(isObject(%obj))
	{
		%obj.mountImage("ZombieFistChargingImage", 0);
		%obj.mountImage("playerTeleportImage", 3);
	}
}

function ZombieSmasherChargingArmor::zombieClaw(%this, %obj)
{
	return false;
}

function ZombieSmasherChargingArmor::zombieDeath(%this, %obj, %objClient, %sourceObject, %sourceClient, %bot, %pos, %damage, %damageType)
{
	if(isObject(%objClient))
	{
		%objClient.setControlObject(%objClient.camera);
	}
	
	return parent::zombieDeath(%this, %obj, %objClient, %sourceObject, %sourceClient, %bot, %pos, %damage, %damageType);
}

function ZombieSmasherChargingArmor::zombieSlowDownCheck(%this, %obj, %conn)
{
	if(isObject(%obj) && isObject(%conn))
	{
		if(%conn.getControlObject() == %obj.getID())
		{
			if(%obj.getState() !$= "Dead")
			{
				%pass = true;
				%dist = vectorDist(%obj.zombieChargerStart, %obj.getPosition());
				%vel = %obj.getVelocity();
				
				if(%obj.zombieInWater || %dist > 64 || vectorLen(%vel) <= 1.5 || %obj.getState() $= "Dead")
				{
					%pass = false;
				}
				else if($sim::time - %obj.zombieChargerStartTime > 3)
				{
					%velMod = vectorScale(%obj.zombieAimVec(), %vel);
					%velX = mAbs(getWord(%velMod, 0));
					%velY = mAbs(getWord(%velMod, 1));
					%velZ = mAbs(getWord(%velMod, 2));
					
					// Are we going sideways almost as fast as (or faster than) we are going forwards..?
					if(%velZ < 2 && %velX < %velY + 1)
					{
						%pass = false;
					}
				}
				
				if(!%pass)
				{
						%obj.changeDatablock("ZombieSmasherArmor");
						%obj.spawnExplosion("PlayerSootProjectile", getWord(%obj.getScale(), 2));
						%obj.playThread(3, "undo");
						%obj.setEnergyLevel(0);
						%obj.unMountImage(3);
						
						%conn.setMove("y", false);
						%conn.schedule(525, "delete");
						
						if(!zombieBot(%obj))
						{
							%obj.client.schedule(500, "setControlObject", %obj);
						}
						else
						{
							applyDefaultCharacterPrefs(%obj);
						}
				}
				else
				{
					%obj.zombieChargingSched = %this.schedule(250, "zombieSlowDownCheck", %obj, %conn);
				}
			}
			else
			{
				%conn.delete();
			}
		}
		else if(!isObject(%conn.getControlObject()))
		{
			%conn.delete();
		}
	}
}

function ZombieSmasherChargingArmor::zombieSpecial(%this, %obj)
{
	return false;
}

// ============================================================
// Section 8 : Smoker
// ============================================================
function ZombieSmokerArmor::onCollision(%this, %obj, %col, %pos, %vel)
{
	if(!zombieBot(%obj) && %obj.zombieSmoking && %col.zombieSmoked)
	{
		%victim = %obj.zombieSmokingWho;
		%smoker = %col.zombieSmokedBy;
		
		if(isObject(%victim) && isObject(%smoker) && %smoker.getID() == %obj.getID() && %victim.getID() == %col.getID())
		{
			%smoker.zombieClaw();
		}
	}
	
	return parent::onCollision(%this, %obj, %col, %pos, %vel);
}

function ZombieSmokerArmor::onDisabled(%this, %obj)
{
	%slot = %obj.getMountSlot(ZombieSmokeImage);
	
	if(%slot > -1)
	{
		%obj.unMountImage(%slot);
	}
	
	%obj.mountImage(ZombieSmokeDeathImage, 2);
	
	return parent::onDisabled(%this, %obj);
}

function ZombieSmokerArmor::onNewDatablock(%this, %obj)
{
	%result = parent::onNewDatablock(%this, %obj);
	
	%slot = %obj.getMountSlot(ZombieSmokeImage);
	
	if(%slot == -1)
	{
		%obj.mountImage(ZombieSmokeImage, 2);
	}
	
	return %result;
}

function ZombieSmokerArmor::zombieChase(%this, %obj, %target)
{
	if(!%obj.zombieSmoking)
	{
		return parent::zombieChase(%this, %obj, %target);
	}
}

function ZombieSmokerArmor::zombieDetectRoute(%this, %obj, %canSee, %dist, %reach, %zDist, %hCol, %lCol, %hHit, %lhit, %fhit)
{
	if(%obj.getType() & $TypeMasks::VehicleObjectType)
	{
		%mounted = %obj.getMountedObjectCount();
		
		if(%mounted)
		{
			%mostMounted = %mount.getDatablock().numMountPoints;
			
			for(%a = 0; %a < %mostMounted; %a++)
			{
				%mountObj = %mount.getMountedObject(%a);
				
				if(zombieValidTarget(%obj, %mountObj))
				{
					%result = %obj.zombieChase(%mountObj);
					
					if(isObject(%result))
					{
						%obj.zombieDetectRoute();
					}
				}
			}
		}
	}
	
	if(%canSee)
	{
		%obj.setMoveObject(-1);
		return "special";
	}
	else
	{
		return parent::zombieDetectRoute(%this, %obj, %canSee, %dist, %reach, %zDist, %hCol, %lCol, %hHit, %lhit, %fhit);
	}
}

function ZombieSmokerArmor::zombieDragToObject(%this, %obj, %victim)
{
	if(isObject(%victim))
	{
		if(isObject(%obj) && zombieValidTarget(%obj, %victim))
		{
			%canStrangle = true;
			
			if(%obj.zombieSee(%victim))
			{
				%canStrangle = true;
			}
			
			if(%canStrangle)
			{
				if($sim::time - %victim.zombieSmokedSince > 3)
				{
					// Dismounting
					%mount = %victim.getObjectMount();
					
					if(isObject(%mount))
					{
						if(!%mount.getDatablock().protectPassengersDirect)
						{
							%victim.dismount();
						}
						else
						{
							return;
						}
					}
					
					// Damaging
					%damage = 1;
					%damage = mDirMod(%damage, %damage * 1.5, getMiniGameFromObject(%obj));
					
					%victim.damage(%obj, %obj.getPosition(), %damage, $DamageType::SmokerStrangle);
					%result = parent::zombieDragToObject(%this, %obj, %victim);
					
					// Helplessness
					if(!%victim.zombieHelpless)
					{
						%victim.currTool = -1;
						%victim.zombieHelpless = true;
						%victim.unMountImage($WeaponSlot);
						%victim.playThread(0, "root");
						%victim.playThread(1, "root");
						%victim.playThread(2, "root");
						%victim.setTransform(%victim.getPosition() SPC getWords(%obj.getTransform(), 4, 6));
						
						if(!zombieBot(%victim.client) && %victim.client.zombieMedpackting)
						{
							%victim.zombieMedpackUse = 0;
							%victim.client.zombieMedpackting = false;
							cancel(%victim.zombieMedpackSched);
							commandToClient(%victim.client, 'centerPrint', "<color:ffaaaa>Heal Disrupted!", 1);
						}
						
						%this.zombieCameraSpectate(%victim);
					}
					
				}
				
				if(!zombieBot(%obj) && !ZombieFriends.isFriend(%obj.client, %victim.client))
				{
					%bars = "<color:aaffaa>";
					%div = 20;
					%tens = mCeil(%victim.getDamagePercent() * %div);
					
					for(%a = 0; %a < %div; %a++)
					{
						if(%a == (%div - %tens))
						{
							%bars = %bars @ "<color:ffaaaa>";
						}
						
						%bars = %bars @ "|";
					}
					
					commandToClient(%obj.client, 'centerPrint', %bars, 0.5);
				}
				
				cancel(%victim.zombieNotHelplessSched);
				cancel(%obj.zombieNotSmokingSched);
				cancel(%obj.zombieStrangleSched);
				
				%eval = %obj.getID() @ ".zombieSmoking = false;";
				%eval = %eval @ %obj.getID() @ ".zombieSmokingWho = \"\";";
				
				%obj.zombieNotSmokingSched = schedule(300, 0, "eval", %eval);
				%obj.zombieStrangleTime = $sim::time;
				%obj.zombieStrangleSched = %this.schedule(250, "zombieDragToObject", %obj, %victim);
			}
		}
		
		%eval = %victim.getID() @ ".zombieHelpless = false;";
		%eval = %eval SPC %victim.getID() @ ".zombieSmoked = false;";
		%eval = %eval SPC %victim.getID() @ ".zombieSmokedBy = \"\";";
		%eval = %eval SPC %victim.getID() @ ".unMountImage(2);";
		
		%victim.zombieNotHelplessSched = schedule(300, 0, "eval",  %eval);
	}
	
	return %result;
}

function ZombieSmokerArmor::zombieSee(%this, %obj, %target)
{
	if(%this.isZombieArmor && isObject(%target))
	{
		%victim = %obj.zombieSmokingWho;
		
		if(isObject(%victim) && %victim.getID() == %target.getID())
		{
			return true;
		}
	}
	
	return parent::zombieSee(%this, %obj, %target);
}

function ZombieSmokerArmor::zombieSmokeCheck(%this, %obj)
{
	if(isObject(%obj) && isObject(%obj.zombieSmokeClient))
	{
		if(%obj.getState() $= "Dead" || (%obj.isZombie && (!isObject(%obj.zombieSmokingWho) || %obj.zombieSmokingWho.getState() $= "Dead")) || (!%obj.isZombie && (!isObject(%obj.zombieSmokedBy) || %obj.zombieSmokedBy.getState() $= "Dead")))
		{
			if(!zombieBot(%obj.zombieSmokeClient))
			{
				if(%obj.getState() $= "Dead")
				{
					%obj.zombieSmokeClient.setControlObject(%obj.zombieSmokeClient.camera);
				}
				else
				{
					%obj.zombieSmokeClient.setControlObject(%obj);
				}
			}
		}
		else
		{
			%obj.zombieSmokingSched = %this.schedule(1000, "zombieSmokeCheck", %obj);
		}
	}
}

function ZombieSmokerArmor::zombieSpecial(%this, %obj)
{
	if(!isEventPending(%obj.zombieStrangleSched))
	{
		%wait = 12;
		
		if($sim::time - %obj.zombieStrangleTime > %wait)
		{
			%start = %obj.getPosition();
			%end = vectorSub(%start, "0 0 0.5");
			%masks = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
			
			%ground = getWord(containerRayCast(%start, %end, %masks, %obj), 0);
			
			if(isObject(%ground))
			{
				// Start
				%start = %obj.getEyePoint();
				
				// End
				%aimVec = %obj.zombieAimVec();
				%end = vectorAdd(%start, vectorScale(%aimVec, 150));
				
				// Masks
				%masks = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
				
				// Raycast
				%col = getWord(containerRayCast(%start, %end, %masks, %obj), 0);
				
				if(zombieSameGame(%obj, %col))
				{
					if(%col.getType() & $TypeMasks::PlayerObjectType)
					{
						if(zombieValidTarget(%obj, %col))
						{
							if(!%col.zombieHelpless && !%col.zombieSmoked)
							{
								%mount = %col.getObjectMount();
								
								if(!isObject(%mount) || !%mount.getDatablock().protectPassengersDirect)
								{
									if(!zombieBot(%col))
									{
										commandToClient(%col.client, 'centerPrint', "<font:impact:32>*SMOKED*\n<font:impact:16>3 seconds before you get pulled.", 3);
										
										switch(getRandom(0, 4))
										{
											case 0: %message = "I'm smoked!";
											case 1: %message = "Smoked, give me a hand!";
											case 2: %message = "Tap me! Tap me! I'm pulled!";
											case 3: %message = "Gah, get the hell over here and break the tongue!";
											case 4: %message = "I cant pull this off myself! Help me!";
											default: %message = "Smoked!";
										}
										
										%col.client.zombieHelp(%message, true);
									}
									
									if(!zombieBot(%obj))
									{
										// Used to fix camera.
										%obj.zombieSmokeClient = %obj.client;
									}
									else
									{
										%obj.setMoveDestination(%obj.getWorldBoxCenter());
										%obj.setAimObject(%col);
									}
									
									%obj.zombieSmokeClient = %obj.client;
									%obj.zombieSmoking = true;
									%obj.zombieSmokingWho = %col;
									%obj.zombieSmokingSince = $sim::time;
									%obj.emote(AlarmProjectile);
									
									%col.zombieSmokeClient = %col.client;
									%col.zombieSmoked = true;
									%col.zombieSmokedBy = %obj;
									%col.zombieSmokedSince = $sim::time;
									%col.emote(AlarmProjectile);
									%col.mountImage(ZombieSmokerConstrictImage, 2);
									
									%this.zombieCameraSpectate(%obj);
									%this.zombieDragToObject(%obj, %col);
									%this.zombieSmokeCheck(%obj);
									%this.zombieSmokeCheck(%col);
								}
								else if(!zombieBot(%obj))
								{
									commandToClient(%obj.client, 'centerPrint', "<font:impact:32>*SPLEAUGH*\n<font:impact:16>Target is protected by their vehicle!", 3);
								}
							}
							else if(!zombieBot(%obj))
							{
								commandToClient(%obj.client, 'centerPrint', "<font:impact:32>*SPLEAUGH*\n<font:impact:16>Target is already helpless!", 3);
							}
						}
					}
				}
			}
		}
		else if(!zombieBot(%obj))
		{
			%timeLeft = mCeil(%wait - ($sim::time - %obj.zombieStrangleTime));
			
			commandToClient(%obj.client, 'centerPrint', "<font:impact:32>*COUGH*\n<font:impact:16>" @ %timeLeft @ "s until Tongue Regrowth!", 1);
		}
	}
}

// ============================================================
// Section 9 : Spitter
// ============================================================
function ZombieSpitterArmor::zombieSpecial(%this, %obj)
{
	if(isObject(getMiniGameFromObject(%obj)))
	{
		if(!isObject(%obj.zombieSpit))
		{
			%count = MissionCleanup.getCount();
			%obj.spawnProjectile(100, "ZombieMolotovProjectile", "0 0 0", 1);
			
			if(MissionCleanup.getCount() > %count)
			{
				%obj.zombieSpit = MissionCleanup.getObject(%count);
				%this.schedule(1000, "zombieSpitDrop", %obj);
			}
		}
		else if(!zombieBot(%obj))
		{
			commandToClient(%obj.client, 'centerPrint', "<font:impact:32><color:ffaaaa>Spit Still Airborne", 2);
		}
	}
	else if(!zombieBot(%obj))
	{
		commandToClient(%obj.client, 'centerPrint', "<font:impact:32><color:ffaaaa>Cannot Spit Outside Minigame", 2);
	}
	
	return %obj.zombieSpit;
}

function ZombieSpitterArmor::zombieSpitDrop(%this, %obj)
{
	if(isObject(%obj.zombieSpit))
	{
		%obj.zombieSpit.Redirect("0 0 -10", false, %obj.client);
	}
}

// ============================================================
// Section 10 : Standard
// ============================================================
function ZombieStandardArmor::zombieSpecial(%this, %obj)
{
	return %obj.zombieSmash();
}

// ============================================================
// Section 11 : SWAT
// ============================================================
function ZombieSWATArmor::Damage(%this, %obj, %sourceObject, %pos, %damage, %damageType)
{
	if(isObject(%obj) && isObject(%sourceObject) && %damage < %this.maxDamage)
	{
		if(%damageType != $DamageType::Burning)
		{
			%fVec = %obj.getForwardVector();
			%vec1 = -getWord(%fVec, 1) SPC getWord(%fVec, 0) SPC 0;	
			%vec2 = vectorNormalize(%sourceObject.initialVelocity);
			
			%damLoc = vectorDot(%vec1, %vec2) > 0;
			%scaleZ = getWord(%obj.getScale(), 2);
			
			if(getWord(%pos, 2) <= getWord(%obj.getWorldBoxCenter(), 2) - (3.4 * %scaleZ))
			{
				return;
			}
		}
	}
	
	return parent::Damage(%this, %obj, %sourceObject, %pos, %damage, %damageType);
}

function ZombieSWATArmor::zombieDress(%this, %obj)
{
	if(zombieBot(%obj))
	{
		// SWAT guy always looks the same, except for his face decal.
		%obj.zombieClothedAs = %this.getID();
		%obj.zombieGender = getRandom(0, 1);
		%obj.zombieSkinColor = %this.getSkinColor(%obj);
		
		%obj.zombieGarmentCount = 10;
		%obj.zombieHat = 0;
		
		%obj.zombieGarment[0] = "none";
		%obj.zombieGarment[1] = $Chest[%obj.zombieGender];
		%obj.zombieGarment[2] = $LArm[%obj.zombieGender];
		%obj.zombieGarment[3] = $RArm[%obj.zombieGender];
		%obj.zombieGarment[4] = "lhand";
		%obj.zombieGarment[5] = "rhand";
		%obj.zombieGarment[6] = "pants";
		%obj.zombieGarment[7] = "lshoe";
		%obj.zombieGarment[8] = "rshoe";
		%obj.zombieGarment[9] = "armor";
		
		%obj.zombieGarmentColor[0] = "0.172897 0.168224 0.186916 1";
		%obj.zombieGarmentColor[1] = "0.172897 0.168224 0.186916 1";
		%obj.zombieGarmentColor[2] = "0.172897 0.168224 0.186916 1";
		%obj.zombieGarmentColor[3] = "0.172897 0.168224 0.186916 1";
		%obj.zombieGarmentColor[4] = "0.172897 0.168224 0.186916 1";
		%obj.zombieGarmentColor[5] = "0.172897 0.168224 0.186916 1";
		%obj.zombieGarmentColor[6] = "0.172897 0.168224 0.186916 1";
		%obj.zombieGarmentColor[7] = "0.172897 0.168224 0.186916 1";
		%obj.zombieGarmentColor[8] = "0.172897 0.168224 0.186916 1";
		%obj.zombieGarmentColor[9] = "0.172897 0.168224 0.186916 1";
		
		%obj.zombieDecalChest = "AAA-None";
		
		switch(%obj.zombieDecalFace)
		{
			case 0: %obj.zombieDecalFace = "ZombieFaceA";
			case 1: %obj.zombieDecalFace = "ZombieFaceB";
			case 2: %obj.zombieDecalFace = "ZombieFaceC";
			case 3: %obj.zombieDecalFace = "ZombieFaceD";
			default: %obj.zombieDecalFace = "smiley";
		}
	}
	else
	{
		%obj.zombieClothedAs = %this.getID();
		
		for(%a = 0; $hat[%a] !$= "" || $Accent[%a] !$= "" || $pack !$= ""; %a++)
		{
			if($hat[%a] !$= "")
			{
				%obj.hideNode($hat[%a]);
			}
			
			if($Accent[%a] !$= "")
			{
				%obj.hideNode($Accent[%a]);
			}
			
			if($pack[%a] !$= "")
			{
				%obj.hideNode($pack[%a]);
			}
		}
		
		%obj.unHideNode("armor");
		%obj.setNodeColor("armor", "0.172897 0.168224 0.186916 1");
	}
	
	// We return a boolean representing "do you want to continue the parent function?"
	return false;
}

function ZombieSWATArmor::zombieSpecial(%this, %obj)
{
	return %obj.zombieSmash();
}

// ============================================================
// Section 12 : Swimmer
// ============================================================
function ZombieSwimmerArmor::onEnterLiquid(%this, %obj)
{
	%this.schedule(32, "zombieSwim", %obj);
	
	return parent::onEnterLiquid(%this, %obj);
}

function ZombieSwimmerArmor::onLeaveLiquid(%this, %obj)
{
	cancel(%obj.zombieSwimmerSwimSched);
	
	return parent::onLeaveLiquid(%this, %obj);
}

function ZombieSwimmerArmor::zombieSpecial(%this, %obj)
{
	if(%obj.zombieInWater)
	{
		%obj.playThread(2, "jump");
		%obj.setVelocity(vectorScale(%obj.zombieAimVec(), 20));
		
		return true;
	}
	else
	{
		return false;
	}
}

function ZombieSwimmerArmor::zombieSwim(%this, %obj)
{
	if(isObject(%obj) && %obj.getState() !$= "Dead" && %obj.zombieInWater)
	{
		if(zombieBot(%obj) && %obj.zombieHasTarget())
		{
			%this.zombieSpecial(%obj);
		}
		
		%obj.zombieSwimmerSwimSched = %this.schedule(200, "zombieSwim", %obj);
	}
}

// ============================================================
// Section 13 : Tank
// ============================================================
function ZombieTankArmor::onNewDatablock(%this, %obj)
{
	%mini = getMiniGameFromObject(%obj);
	
	if(zombieGameSetUpRight(%mini))
	{
		%mini.messageAll('', "<color:ffaaaa>Dun dun dun DUN.");
	}
	
	parent::onNewDatablock(%this, %obj);
	
	if(isObject(%obj))
	{
		%obj.mountImage(ZombieFistRightImage, 0);
		%obj.mountImage(ZombieFistLeftImage, 1);
	}
}

function ZombieTankArmor::Damage(%this, %obj, %sourceObject, %pos, %damage, %damageType)
{
	%mini = getMiniGameFromObject(%obj);
	
	if(zombieGameSetUpRight(%mini))
	{
		%humans = %mini.getNumberOfHumans();
		
		%damage /= (%humans / 4);
	}
	
	return parent::Damage(%this, %obj, %sourceObject, %pos, %damage, %damageType);
}

function ZombieTankArmor::zombieConsume(%this, %obj, %col)
{
	if(zombieSameGame(%obj, %col))
	{
		// Energy
		%energy = %obj.getEnergyLevel();
		
		if(%energy > 25 && $sim::time - %obj.zombieLastClaw > 0.25)
		{
			%obj.setEnergyLevel(%energy - 25);
			%obj.zombieLastClaw = $sim::time;
			
			%pos = %obj.getPosition();
			
			if(!%col.isZombie)
			{
				%damage = %obj.getDatablock().zombieDamage;
				
				%mini = getMiniGameFromObject(%obj);
				
				if(zombieGameSetUpRight(%mini))
				{
					%humans = %mini.getNumberOfHumans();
					
					%damage *= (%humans / 4);
				}
			}
			else
			{
				%damage = 100;
			}
			
			if(%this.zombieDamType !$= "")
			{
				%damageType = %this.zombieDamType;
			}
			else
			{
				%damageType = $DamageType::Zombies;
			}
			
			if(!zombieBot(%obj))
			{
				commandToClient(%obj.client, 'centerPrint', "<font:impact:32>*PUNCH*\n<font:impact:16>Waaahahaha!", 0.5);
			}
			
			if(!zombieBot(%col))
			{
				if(!%col.isZombie)
				{
					commandToClient(%col.client, 'centerPrint', "<font:impact:32>*PUNCHED*\n<font:impact:16>Shoot this big mother~!", 0.5);
				}
				else
				{
					commandToClient(%col.client, 'centerPrint', "<font:impact:32>*PUNCHED*", 0.5);
				}
			}
			
			if(isObject(%col.getMountedImage(2)) && %col.getMountedImage(2).getID() == ZombieSmokerConstrictImage.getID())
			{
				%col.unMountImage(2);
			}
			
			cancel(%col.zombieSmokedBy.zombieStrangleSched);
			%col.zombieHelpless = false;
			%col.zombieSmoked = false;
			%col.zombieSmokedBy = "";
			
			%col.zombieJockeyDismount();
			
			%velocity = vectorAdd(%col.getVelocity(), vectorScale(getWords(%obj.getForwardVector(), 0, 1) SPC 0.50, 15));
			%col.setVelocity(%velocity);
			
			%col.spawnExplosion("ZombiePunchProjectile", 1.5, -1);
			%col.damage(%obj, %pos, %damage, %damageType);
			%obj.zombieLastClawDamage = $sim::time;
			
			return true;
		}
	}
	
	return false;
}

function ZombieTankArmor::zombieClaw(%this, %obj)
{
	%hit = parent::zombieClaw(%this, %obj);
	
	if(isObject(%hit) && miniGameCanDamage(%obj, %hit) && (%hit.getType() & $TypeMasks::VehicleObjectType) != 0)
	{
		%damage = 100;
		%obj.spawnExplosion("ZombiePunchProjectile", 1.5 ,-1);
		%hit.damage(%obj, %pos, %damage, %damageType);
		
		%dif = vectorNormalize(getWords(vectorSub(%hit.getPosition(), %obj.getPosition()), 0, 1));
		%newVec = (getWord(%dif, 0) * %eXY) SPC (getWord(%dif,1 ) * %eXY) SPC 0.5;
		%hit.setVelocity(vectorAdd(%hit.getVelocity(), vectorScale(%newVec, 15)));
		
		if(!zombieBot(%obj))
		{
			commandToClient(%obj.client, 'centerPrint', "<font:impact:32>*PUNCH*\n<font:impact:16>Waaahahaha!", 0.5);
		}
	}
	
	return %hit;
}

function ZombieTankArmor::zombieDress(%this, %obj)
{
	%obj.zombieClothedAs = %this.getID();
	%obj.zombieDecalFace = "TankFace";
	
	return false;
}

function ZombieTankArmor::zombieSpecial(%this, %obj)
{
	return %obj.zombieSmash();
}